<a id="types-aiobotocore-cloudformation"></a>

# types-aiobotocore-cloudformation

[![PyPI - types-aiobotocore-cloudformation](https://img.shields.io/pypi/v/types-aiobotocore-cloudformation.svg?color=blue)](https://pypi.org/project/types-aiobotocore-cloudformation)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-cloudformation.svg?color=blue)](https://pypi.org/project/types-aiobotocore-cloudformation)
[![Docs](https://img.shields.io/readthedocs/types-aiobotocore.svg?color=blue)](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_cloudformation/)
[![PyPI - Downloads](https://static.pepy.tech/badge/types-aiobotocore-cloudformation)](https://pepy.tech/project/types-aiobotocore-cloudformation)

![boto3.typed](https://github.com/youtype/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[aiobotocore.CloudFormation 2.11.0](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/cloudformation.html#CloudFormation)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.23.1](https://github.com/youtype/mypy_boto3_builder).

More information can be found on
[types-aiobotocore](https://pypi.org/project/types-aiobotocore/) page and in
[types-aiobotocore-cloudformation docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_cloudformation/).

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/youtype/mypy_boto3_builder/raw/main/demo.gif)

- [types-aiobotocore-cloudformation](#types-aiobotocore-cloudformation)
  - [How to install](#how-to-install)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Waiters annotations](#waiters-annotations)
    - [Service Resource annotations](#service-resource-annotations)
    - [Other resources annotations](#other-resources-annotations)
    - [Collections annotations](#collections-annotations)
    - [Literals](#literals)
    - [Type definitions](#type-definitions)
  - [How it works](#how-it-works)
  - [What's new](#what's-new)
    - [Implemented features](#implemented-features)
    - [Latest changes](#latest-changes)
  - [Versioning](#versioning)
  - [Thank you](#thank-you)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `CloudFormation` service.

```bash
# install with aiobotocore type annotations
python -m pip install 'types-aiobotocore[cloudformation]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'types-aiobotocore-lite[cloudformation]'


# standalone installation
python -m pip install types-aiobotocore-cloudformation
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y types-aiobotocore-cloudformation
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[cloudformation]` in your environment:

```bash
python -m pip install 'types-aiobotocore[cloudformation]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `types-aiobotocore-lite[cloudformation]` in your environment:

```bash
python -m pip install 'types-aiobotocore-lite[cloudformation]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `types-aiobotocore` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `types-aiobotocore` with services you use in your environment:

```bash
python -m pip install 'types-aiobotocore[cloudformation]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed
  `types-aiobotocore`

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `types-aiobotocore[cloudformation]` with services you use in your
  environment:

```bash
python -m pip install 'types-aiobotocore[cloudformation]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[cloudformation]` in your environment:

```bash
python -m pip install 'types-aiobotocore[cloudformation]'`
```

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `types-aiobotocore[cloudformation]` in your environment:

```bash
python -m pip install 'types-aiobotocore[cloudformation]'
```

Optionally, you can install `types-aiobotocore` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`CloudFormationClient` provides annotations for
`session.create_client("cloudformation")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_cloudformation import CloudFormationClient

session = get_session()
async with session.create_client("cloudformation") as client:
    client: CloudFormationClient
    # now client usage is checked by mypy and IDE should provide code completion
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_cloudformation.paginator` module contains type annotations
for all paginators.

```python
from aiobotocore.session import get_session

from types_aiobotocore_cloudformation import CloudFormationClient
from types_aiobotocore_cloudformation.paginator import (
    DescribeAccountLimitsPaginator,
    DescribeChangeSetPaginator,
    DescribeStackEventsPaginator,
    DescribeStacksPaginator,
    ListChangeSetsPaginator,
    ListExportsPaginator,
    ListImportsPaginator,
    ListStackInstancesPaginator,
    ListStackResourcesPaginator,
    ListStackSetOperationResultsPaginator,
    ListStackSetOperationsPaginator,
    ListStackSetsPaginator,
    ListStacksPaginator,
    ListTypesPaginator,
)

session = get_session()
async with session.create_client("cloudformation") as client:
    client: CloudFormationClient

    # Explicit type annotations are optional here
    # Types should be correctly discovered by mypy and IDEs
    describe_account_limits_paginator: DescribeAccountLimitsPaginator = client.get_paginator(
        "describe_account_limits"
    )
    describe_change_set_paginator: DescribeChangeSetPaginator = client.get_paginator(
        "describe_change_set"
    )
    describe_stack_events_paginator: DescribeStackEventsPaginator = client.get_paginator(
        "describe_stack_events"
    )
    describe_stacks_paginator: DescribeStacksPaginator = client.get_paginator("describe_stacks")
    list_change_sets_paginator: ListChangeSetsPaginator = client.get_paginator("list_change_sets")
    list_exports_paginator: ListExportsPaginator = client.get_paginator("list_exports")
    list_imports_paginator: ListImportsPaginator = client.get_paginator("list_imports")
    list_stack_instances_paginator: ListStackInstancesPaginator = client.get_paginator(
        "list_stack_instances"
    )
    list_stack_resources_paginator: ListStackResourcesPaginator = client.get_paginator(
        "list_stack_resources"
    )
    list_stack_set_operation_results_paginator: ListStackSetOperationResultsPaginator = (
        client.get_paginator("list_stack_set_operation_results")
    )
    list_stack_set_operations_paginator: ListStackSetOperationsPaginator = client.get_paginator(
        "list_stack_set_operations"
    )
    list_stack_sets_paginator: ListStackSetsPaginator = client.get_paginator("list_stack_sets")
    list_stacks_paginator: ListStacksPaginator = client.get_paginator("list_stacks")
    list_types_paginator: ListTypesPaginator = client.get_paginator("list_types")
```

<a id="waiters-annotations"></a>

### Waiters annotations

`types_aiobotocore_cloudformation.waiter` module contains type annotations for
all waiters.

```python
from aiobotocore.session import get_session

from types_aiobotocore_cloudformation.client import CloudFormationClient
from types_aiobotocore_cloudformation.waiter import (
    ChangeSetCreateCompleteWaiter,
    StackCreateCompleteWaiter,
    StackDeleteCompleteWaiter,
    StackExistsWaiter,
    StackImportCompleteWaiter,
    StackRollbackCompleteWaiter,
    StackUpdateCompleteWaiter,
    TypeRegistrationCompleteWaiter,
)

session = get_session()
async with session.create_client("cloudformation") as client:
    client: CloudFormationClient

    # Explicit type annotations are optional here
    # Types should be correctly discovered by mypy and IDEs
    change_set_create_complete_waiter: ChangeSetCreateCompleteWaiter = client.get_waiter(
        "change_set_create_complete"
    )
    stack_create_complete_waiter: StackCreateCompleteWaiter = client.get_waiter(
        "stack_create_complete"
    )
    stack_delete_complete_waiter: StackDeleteCompleteWaiter = client.get_waiter(
        "stack_delete_complete"
    )
    stack_exists_waiter: StackExistsWaiter = client.get_waiter("stack_exists")
    stack_import_complete_waiter: StackImportCompleteWaiter = client.get_waiter(
        "stack_import_complete"
    )
    stack_rollback_complete_waiter: StackRollbackCompleteWaiter = client.get_waiter(
        "stack_rollback_complete"
    )
    stack_update_complete_waiter: StackUpdateCompleteWaiter = client.get_waiter(
        "stack_update_complete"
    )
    type_registration_complete_waiter: TypeRegistrationCompleteWaiter = client.get_waiter(
        "type_registration_complete"
    )
```

<a id="service-resource-annotations"></a>

### Service Resource annotations

`CloudFormationServiceResource` provides annotations for
`aiobotocore.resource("cloudformation")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_cloudformation import CloudFormationServiceResource

session = get_session()
async with session.resource("cloudformation") as resource:
    resource: CloudFormationServiceResource
    # now resource usage is checked by mypy and IDE should provide code completion
```

<a id="other-resources-annotations"></a>

### Other resources annotations

`types_aiobotocore_cloudformation.service_resource` module contains type
annotations for all resources.

```python
from aiobotocore.session import get_session

from types_aiobotocore_cloudformation import CloudFormationServiceResource
from types_aiobotocore_cloudformation.service_resource import (
    Event,
    Stack,
    StackResource,
    StackResourceSummary,
)

session = get_session()
async with session.resource("cloudformation") as resource:
    resource: CloudFormationServiceResource

    # Explicit type annotations are optional here
    # Type should be correctly discovered by mypy and IDEs
    my_event: Event = resource.Event(...)
    my_stack: Stack = resource.Stack(...)
    my_stack_resource: StackResource = resource.StackResource(...)
    my_stack_resource_summary: StackResourceSummary = resource.StackResourceSummary(...)
```

<a id="collections-annotations"></a>

### Collections annotations

`types_aiobotocore_cloudformation.service_resource` module contains type
annotations for all `CloudFormationServiceResource` collections.

```python
from aiobotocore.session import get_session

from types_aiobotocore_cloudformation import CloudFormationServiceResource
from types_aiobotocore_cloudformation.service_resource import ServiceResourceStacksCollection

session = get_session()
async with session.resource("cloudformation") as resource:
    resource: CloudFormationServiceResource

    # Explicit type annotations are optional here
    # Type should be correctly discovered by mypy and IDEs
    stacks: cloudformation_resources.ServiceResourceStacksCollection = resource.stacks
```

<a id="literals"></a>

### Literals

`types_aiobotocore_cloudformation.literals` module contains literals extracted
from shapes that can be used in user code for type checking.

Full list of `CloudFormation` Literals can be found in
[docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_cloudformation/literals/).

```python
from types_aiobotocore_cloudformation.literals import AccountFilterTypeType


def check_value(value: AccountFilterTypeType) -> bool: ...
```

<a id="type-definitions"></a>

### Type definitions

`types_aiobotocore_cloudformation.type_defs` module contains structures and
shapes assembled to typed dictionaries and unions for additional type checking.

Full list of `CloudFormation` TypeDefs can be found in
[docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_cloudformation/type_defs/).

```python
from types_aiobotocore_cloudformation.type_defs import AccountGateResultTypeDef


def get_value() -> AccountGateResultTypeDef:
    return {...}
```

<a id="how-it-works"></a>

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for
`aiobotocore` updates. It delivers drop-in type annotations for you and makes
sure that:

- All available `aiobotocore` services are covered.
- Each public class and method of every `aiobotocore` service gets valid type
  annotations extracted from `botocore` schemas.
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

<a id="what's-new"></a>

## What's new

<a id="implemented-features"></a>

### Implemented features

- Fully type annotated `boto3`, `botocore`, `aiobotocore` and `aioboto3`
  libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.resource` calls
- Auto discovery of types for `session.client` and `session.resource` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

<a id="latest-changes"></a>

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/youtype/mypy_boto3_builder/releases).

<a id="versioning"></a>

## Versioning

`types-aiobotocore-cloudformation` version is the same as related `aiobotocore`
version and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/)
format.

<a id="thank-you"></a>

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

<a id="documentation"></a>

## Documentation

All services type annotations can be found in
[aiobotocore docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_cloudformation/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder/issues/)
repository.
